<template>
  <div @keyup.enter="sendDataOfUser">
    <additional-phone :params="configAdditionalPhoneOwner" ref="AdditionalPhone"></additional-phone>
    <work-information :params="configWorkInformation" ref="WorkInformation"></work-information>
    <additional-information ref="AdditionalInformation"></additional-information>
    <publicity-information ref="PublicityInformation"></publicity-information>
    <beneficial-information ref="BeneficialInformation"></beneficial-information>

    <div class="center">
      <!--<button @click='sendDataOfUser' :disabled="!agree">Продолжить</button>-->
      <div v-if="allFields" class="warning-red-block" style="padding-bottom: 20px;">
        <div class="close" @click="allFields = false"></div>
        Не заполнены обязательные поля. Пожалуйста, заполните их и снова нажмите кнопку продолжить
      </div>
      <button @click='sendDataOfUser'
              :disabled="$interface.buttonLoading"
              :class="{button_loading: $interface.buttonLoading}">
        Продолжить</button>
    </div>
  </div>
</template>

<script>
  import AdditionalPhone from '@/components/User/AdditionalPhone'
  import WorkInformation from '@/components/User/WorkInformation'
  import AdditionalInformation from '@/components/User/AdditionalInformation/AdditionalInfo'
  import PublicityInformation from '@/components/User/PublicityInformation'
  import BeneficialInformation from '@/components/User/BeneficialInformation'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import {AUTH_SUCCESS} from '@/store/mutation-types'

  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import {focus} from '@/components/Validators/focus'
  import ErrorLog from '@/mixins/ErrorLog.js';

  export default {
    name: 'third-page',
    data () {
      return {
        errors: [],
        configAdditionalPhoneOwner: {
          eventGetOwner: 'clarifyOwner'
        },
        configWorkInformation: {
          pageWorkInformation: 'registrationPage'
        },
        allFields: false
      }
    },
    // watch: {
    //   user: {
    //     handler () {
    //       this.setState()
    //     },
    //     immediate: false
    //   }
    // },
    mixins: [
      UserGetter,
      UserSetter,
      IndicatorRegistration,
      ErrorLog
    ],
    components: {
      AdditionalPhone,
      WorkInformation,
      AdditionalInformation,
      PublicityInformation,
      BeneficialInformation,
      IndicatorRegistration
    },
    computed: {
      validation () {
        return this.$user.validate.step3;
      }
    },
    methods: {
      /**
       * Обновление данных о валидации.
       * @returns {Promise<void>}
       */
      async setState () {
        let access = this.$refs;
          if (this.$user.typeOfEmployment === 1) {
          await access.WorkInformation.$refs.employee.$validator.validateAll().then(val => {
            this.$user.validate.other.employer = val;
          })
          await access.WorkInformation.$refs.WorkAddress.$validator.validateAll().then(val => {
            console.log('Work address validation:', val);
            this.$user.validate.other.workAddress = val;
          })
        }
        if (this.$user.typeOfEmployment === 2) {
          // await access.WorkInformation.$refs.businessman.$validator.validateAll().then(val => this.$user.validate.other.businessman = val)
        }
        if (this.$user.typeOfEmployment === 3) {
          await access.WorkInformation.$refs.FounderFullName.$validator.validateAll().then(val => this.$user.validate.other.founderFullName = val)
          // await access.WorkInformation.$refs.businessman.$validator.validateAll().then(val => this.$user.validate.other.businessman = val)
        }
        await access.AdditionalPhone.$validator.validateAll().then(val => this.$user.validate.step3.additionPhone = val)
        await access.WorkInformation.$validator.validateAll().then(val => this.$user.validate.step3.workInformation = val)
        await access.AdditionalInformation.$validator.validateAll().then(val => this.$user.validate.step3.additionalInfo = val)
        await access.PublicityInformation.$validator.validateAll().then(val => this.$user.validate.step3.publicInformation = val)
        await access.BeneficialInformation.$validator.validateAll().then(val => this.$user.validate.step3.beneficialInformation = val)

        return Promise.resolve();
      },

      async sendDataOfUser () {
        await this.setState();

        /**
         * Проверка доп-полей для наемного сотрудника
         */
        if (this.$user.typeOfEmployment === 1) {
          if (!this.$user.validate.other.workAddress) {
            this.$nextTick(() => {
              this.$toastr.error('Данные о рабочем адресе указаны не верно', 'Требуется исправление');
              this.$helpers.focus();
            })
            return;
          }
        }

        if (!this.$validate.step3) {
          this.$nextTick(() => {
            this.$toastr.error('Заполните все обязательные поля', 'Ошибка')
            this.$helpers.focus()
          })
        } else {
          this.BUTTON_LOADING(true);
          this.allFields = false;
          this.$user.final = 1;
          this.AJAX_LOADING(true);
          this.$store.dispatch('CREATE_USER', [
            'final',
            'storageKey',
            'passportEsiaStatus',
            'lastName',
            'firstName',
            'middleName',
            'email',
            'smsCode',
            'mobilePhone',
            'bDay',
            'bPlace',
            'gender',
            'passport',
            'passportDivisionCode',
            'passportDateOfIssue',
            'passportIssuedBy',
            'address.postalCode',
            'address.region',
            'address.city',
            'address.settlement',
            'address.street',
            'address.doNotHaveStreet',
            'address.house',
            'address.geoLat',
            'address.geoLon',
            'address.housing',
            'address.building',
            'address.flat',

            'addressFiases.value',
            'addressFiases.region_fias_id',
            'addressFiases.area_fias_od',
            'addressFiases.city_fias_id',
            'addressFiases.settlement_fias_id',
            'addressFiases.street_fias_id',
            'addressFiases.house_fias_id',

            'additionalPhone', 'additionalPhoneOwner', 'typeOfEmployment', 'workSalary', 'workFullName', 'workType', 'workScope', 'workName', 'workPhone',
            'workNumberOfEmployees', 'workPeriod', 'workPosition', 'workINN',
            'workAddress.postalCode', 'workAddress.region', 'workAddress.city', 'workAddress.settlement', 'workAddress.street', 'workAddress.doNotHaveStreet',
            'workAddress.house', 'workAddress.geoLat', 'workAddress.geoLon', 'workAddress.housing', 'workAddress.building', 'workAddress.flat',
            'workAddressFiases.value', 'workAddressFiases.region_fias_id', 'workAddressFiases.area_fias_od', 'workAddressFiases.city_fias_id', 'workAddressFiases.settlement_fias_id',
            'workAddressFiases.street_fias_id', 'workAddressFiases.house_fias_id',
            'educationType', 'maritalStatus', 'numberOfChildren', 'sourceOfInformation', 'hasPreviousConviction',
            'publicity.officialState', 'publicity.officialOwnerIsMe', 'publicity.officialName', 'publicity.internationalOrganizationState', 'publicity.internationalOrganizationOwnerIsMe',
            'publicity.internationalOrganizationName', 'publicity.officialRussiaState', 'publicity.officialRussiaOwnerIsMe', 'publicity.officialRussiaName', 'publicity.benefitsOfAnotherPerson',
            'beneficial.state', 'beneficial.lastName', 'beneficial.firstName', 'beneficial.middleName', 'beneficial.passport', 'beneficial.passportDivisionCode', 'beneficial.passportDateOfIssue'
          ])
            .then(async (response) => {

              this.$store.commit('AUTH_SUCCESS', {data: response.data.data, authState: 'authorized'});
              this.$methods.user.setToken(response.data.data);

              if (this.$user.promo.code && !this.$user.promo.percent) {
                console.log('%creset promo code', 'font-weight:bold;')
                this.$user.promo.code = '';
              }

              return this.$backend.api.calc.get().then(async ({data}) => {
                this.$store.commit('LOAN_SET_CALC', data.data);
                await this.$methods.user.getUserData();
                await this.$store.dispatch('ADDITIONAL_SERVICES_LOAD_LIST');

                this.$backend.log({
                  reg_step: 3,
                  user_login: this.$user.login,
                  user_hash: this.$user.hash,
                  user_phone: this.$user.mobilePhone.replace(/[^\d]/g, ''),
                  user_name: `${this.$user.lastName} ${this.$user.firstName} ${this.$user.middleName}`
                });

                this.$user.regStep = 4;
                document.location.hash = 'step4';
                window.Analityc.reg_step3();

                return Promise.resolve();
              })
            })
            .catch((e) => {
              /*передать родительскому компоненту ошибку*/
              this.$emit('errorResponse', e);

              if(e.errors && Array.isArray(e.errors)) {
                e.errors.forEach((er) => {
                  this.$errorField(er.code);
                });

                const mapper = require('../../../utils/error_mapper/user').default;
                const errorMap = mapper[e.errors[0].code];
                if(errorMap) {
                  this.$toastr.error(errorMap.message, 'Ошибка');
                  this.$nextTick(() => {
                    this.$helpers.focus();
                  });
                } else {
                  this.$toastr.error('Произошла непредвиденная ошибка.', 'Ошибка');
                }

              } else {
                this.$backend.log({
                  lk_log: 'reg_error',
                  step: 3,
                  error: typeof e.getMessage === "function" ? e.getMessage() : e.message,
                  user_hash: this.$user.hash,
                  user_phone: this.$user.mobilePhone.replace(/[^\d]/g, ''),
                  user_name: `${this.$user.lastName} ${this.$user.firstName} ${this.$user.middleName}`
                });
              }
            })
            .finally(() => {
              this.$store.commit('BUTTON_LOADING', false);
              this.AJAX_LOADING(false);
            })
        }
      }
    },
    mounted () {
      this.$store.commit('UNSET_ERRORS');
      this.$helpers.scroll(this.$parent.$el);
    },
    updated () {
      // this.setState()
    }
  }
</script>

<style scoped lang="scss">
  .white {
    cursor: default;
    color: #b4cadd;
    background: #fff;
  }

  .white:hover {
    background: #fff;
  }
</style>


